{ Program bada czy dwa odcinki przecinaj si }
program przecinanie_odcinkow;
uses
  Crt, Math;

type
  TPunkt=Record   { rekord przechowujcy dane o punkcie }
    x : Real;
    y : Real;
  end;

{ Procedura pomocnicza, ktra zbiera info o punkcie w jednym rekordzie }
procedure punkt(x,y : Real; var punkt : TPunkt);
begin
  punkt.x:= x;
  punkt.y:= y;
end;

{ Funkcja oblicza odlego miedzy dwoma punktami - dugo odcinka }
function odl_pkt(p1,p2 : TPunkt) : Real;
var
  odlX,
  odlY : Real;

begin
  odlX:=p1.x-p2.x;
  odlY:=p1.y-p2.y;
  odl_pkt:=sqrt(odlY*odlY+odlX*odlX);
end;

{ Funkcja oblicza warto wyznacznika postaci: }
{ |p.x p.y 1| }
{ |q.x q.y 1| }
{ |r.x r.y 1| }
function det(p,q,r : TPunkt) : Real;
begin
  det:=p.x*q.y + p.y*r.x + q.x*r.y - r.x*q.y - r.y*p.x - q.x*p.y;
end;

{ Funkcja obliczajca min z wartoci a,b }
function min(a,b : Real) : Real;
begin
  if a<b then min:=a
  else min:=b;
end;

{ Funkcja obliczajca max z wartoci a,b }
function max(a,b : Real) : Real;
begin
  if a<b then max:=b
  else max:=a;
end;

{ Funkcja sprawdza czy punkt p3, ktry jest wspliniowy z odcinkiem }
{ wyznaczonym przez punkty p1 i p2, ley na tym odcinku }
function na_odcinku(p1,p2,p3 : TPunkt) : Boolean;
var
  wynik : Boolean;
begin
  wynik:=false;
  if (min(p1.x,p2.x) <= p3.x) and (p3.x <= max(p1.x,p2.x))
     and
     (min(p1.y, p2.y) <=p3.y) and (p3.y <= max(p1.y,p2.y)) then wynik:=true;

  na_odcinku:=wynik;
end;

{ Funkcja sprawdza czy dwa odcinki o kocach p1,p2 i p3,p4 si przecinaj }
function odcinki_sie_przecinaja(p1, p2, p3, p4 : TPunkt) : Boolean;
var
  d1, d2, d3, d4 : Real;
  wynik : Boolean;
begin
  wynik:=false;
  { Badamy czy odcinek p1p2 przekracza odcinek p3p4 }
  d1:=det(p3, p4, p1); { badamy pooenie koca (p1) odcinka p1p2 wzgldem odcinka p3p4 }
  d2:=det(p3, p4, p2); { badamy pooenie koca (p2) odcinka p1p2 wzgldem odcinka p3p4 }

  { Badamy czy odcinek p3p4 przekracza odcinek p1p2 }
  d3:=det(p1, p2, p3); { badamy pooenie koca (p3) odcinka p3p4 wzgldem odcinka p1p2 }
  d4:=det(p1, p2, p4); { badamy pooenie koca (p4) odcinka p3p4 wzgldem odcinka p1p2 }

  { Jeli d1*d2<0 i d3*d4<0 oznacza to, e d1 i d2 a take d3 i d4 maj rne znaki. }
  { A wic p1 i p2 le po przeciwnych stronach odcinka p3p4, a p3 i p4 po przeciwnych stronach odcinka p1p2 }
  { Zatem odcinki p1p2 i p3p4 si przekraczaj }
  if (d1*d2<0) and (d3*d4<0) then wynik:=true
  else
    { Jeli det ma warto 0, to jeden z punktw jest wspliniowy z odcinkiem }
    { i sprwdzamy czy punkt ten ley na tym odcinku }
    if (d1=0) and na_odcinku(p3,p4,p1) then wynik:=true
    else
      if (d2=0) and na_odcinku(p3,p4,p2) then wynik:=true
      else
        if (d3=0) and na_odcinku(p1,p2,p3) then wynik:=true
        else
          if (d4=0) and na_odcinku(p1,p2,p4) then wynik:=true;

  odcinki_sie_przecinaja:=wynik;
end;

var
  p1, p2,
  p3, p4 : TPunkt;
begin
  clrscr;
  writeln('Program sprawdza czy dwa odcinki przecinaj si');

  { / \ }
  {I odcinek }
  punkt(0.5,2,p1);    { pocztek odcinka }
  punkt(3.5,3.5,p2);  { koniec odcinka   }

  {II odcinek }
  punkt(1,4,p3);  { pocztek odcinka }
  punkt(2,1,p4);  { koniec odcinka   }
(*
  {-----------------------------}
  { - \ }
  {I odcinek }
  punkt(0.5,2.5,p1);  { pocztek odcinka }
  punkt(3.5,2.5,p2);  { koniec odcinka   }

  {II odcinek }
  punkt(1,4,p3);  { pocztek odcinka }
  punkt(2,1,p4);  { koniec odcinka   }

  {-----------------------------}
  { \ | }
  {I odcinek }
  punkt(0.5,2,p1);    { pocztek odcinka }
  punkt(3.5,3.5,p2);  { koniec odcinka   }

  {II odcinek }
  punkt(1.5,4,p3);  { pocztek odcinka }
  punkt(1.5,1,p4);  { koniec odcinka   }

  {-----------------------------}
  { - | }
  {I odcinek }
  punkt(0.5,2.5,p1);  { pocztek odcinka }
  punkt(3.5,2.5,p2);  { koniec odcinka   }

  {II odcinek }
  punkt(1.5,4,p3);  { pocztek odcinka }
  punkt(1.5,1,p4);  { koniec odcinka   }

  {-----------------------------}
  { / \ proste maja punkt przecicia, ale odcinki nie przecinaj si }
  {I odcinek }
  punkt(0.5,4.5,p1);  { pocztek odcinka }
  punkt(1.5,1.5,p2);  { koniec odcinka   }

  {II odcinek }
  punkt(0.5,0.5,p3);  { pocztek odcinka }
  punkt(3.5,2,p4);    { koniec odcinka   }

  {-----------------------------}
  { // }
  {I odcinek }
  punkt(0.5,2,p1);    { pocztek odcinka }
  punkt(3.5,3.5,p2);  { koniec odcinka   }

  {II odcinek }
  punkt(0.5,3,p3);    { pocztek odcinka }
  punkt(3.5,4.5,p4);  { koniec odcinka   }

  {-----------------------------}
  { \\ }
  {I odcinek }
  punkt(1,4,p1);    { pocztek odcinka }
  punkt(2,1,p2);    { koniec odcinka   }

  {II odcinek }
  punkt(1,3,p3);    { pocztek odcinka }
  punkt(2,0,p4);    { koniec odcinka   }

  {-----------------------------}
  { = }
  {I odcinek }
  punkt(0.5,2.5,p1);  { pocztek odcinka }
  punkt(3.5,2.5,p2);  { koniec odcinka   }

  {II odcinek }
  punkt(0.5,1.5,p3);  { pocztek odcinka }
  punkt(3.5,1.5,p4);  { koniec odcinka   }

  {-----------------------------}
  { || }
  {I odcinek }
  punkt(2.5,0.5,p1);  { pocztek odcinka }
  punkt(2.5,3.5,p2);  { koniec odcinka   }

  {II odcinek }
  punkt(1.5,0.5,p3);  { pocztek odcinka }
  punkt(1.5,3.5,p4);  { koniec odcinka   }
*)
  {-----------------------------}
  writeln('I odcinek');
  write('Pocztek odcinka: ');
  writeln('(',p1.x:6:2,',',p1.y:6:2,')');

  write('Koniec odcinka:   ');
  writeln('(',p2.x:6:2,',',p2.y:6:2,')');

  writeln;

  writeln('II odcinek');
  write('Pocztek odcinka: ');
  writeln('(',p3.x:6:2,',',p3.y:6:2,')');

  write('Koniec odcinka:   ');
  writeln('(',p4.x:6:2,',',p4.y:6:2,')');

  writeln;

  { sprawdzamy czy odcinek nie jest zerowej dugoci }
  write('Dugo odcinka I: ');
  writeln(odl_pkt(p1,p2):6:2);

  write('Dlugosc odcinka II: ');
  writeln(odl_pkt(p3,p4):6:2);

  writeln;
  if odcinki_sie_przecinaja(p1,p2,p3,p4) then
    writeln('Odcinki si przecinaj')
  else
    writeln('Odcinki si nie przecinaj');

  repeat until keypressed;
end.
W komentarzach umieszczone s rzne przypadki odcinkw, ktre
moesz wykorzysta do testowania programu.
