{ Program rysuje trjktny dywan Sierpiskiego }
program dywan_Sierpinskiego;
uses
  Crt, Graph;

{ Procedura rysuje trjkt rwnoboczny o boku a i rodku (x,y) }
procedure trojkat (a,x,y : Integer);
var
  p,
  hp: Integer;
begin
  { poowa dugoci boku }
  p:=a div 2;
  { poowa wysokoci - inna rozdzielczo w pionie }
  hp:=Round(0.433*a);
  begin
    SetColor(2);
    { Procedura MoveTo przemieszcza kursor do punktu o okrelonych wsprzdnych }
    MoveTo(x,y-hp);

    { Procedura LineTo rysuje lini zaczynajc si w punkcie wskazywanym }
    { przez kursor graficzny i koczc si w punkcie o podanych wsprzdnych }
    LineTo(x+p,y+hp);
    LineTo(x-p,y+hp);
    LineTo(x,y-hp);
    SetFillStyle(SolidFill,0);
    FloodFill(x,y,0);
  end;
end;

{ Procedura wycina trjkt o nastpujcych parametrach: }
{ stopie - poziom rekurencji }
{ a - bok wycinanego trjkta }
{ x, y - wsprzdne rodka wycinanego trjkta }
procedure wytnij_trojkat(stopien,a,x,y : Integer);
var
  p, hp,
  q, r : Integer;
begin
  p:=a div 2;
  q:=a div 4;
  if q>=1 then
  begin
    hp:=Round(0.43*a);
    begin
      MoveTo(x,y+hp);
      { rysuje wycinany trjkt }
      { procedura LineTo rysuje linie zaczynajc si }
      { w punkcie wskazywanym przez kursor graficzny }
      { Trzy linie rysuj wycinany trjkt }
      LineTo(x-q,y);
      LineTo(x+q,y);
      LineTo(x,y+hp);

      { wycity trjkt wypenia kolorem }
      SetFillStyle(SolidFill,2);
      FloodFill(x,y+1,2);
      if stopien>1 then
        begin
          r:=Round(0.215*a);
          wytnij_trojkat(stopien-1,p,x,y-r);
          wytnij_trojkat(stopien-1,p,x+q,y+r);
          wytnij_trojkat(stopien-1,p,x-q,y+r);
        end;
    end;
  end;
end;

{ Procedura rysuje dywan o zadanym poziomie rekurencji }
procedure dywan(stopien : Integer);
var
  bok,
  x,y : Integer;
begin
   { bok trjkta - caego dywanu }
   bok:=500;
   { wsprzdne rodka trjkta }
   x:=480;
   y:=330;

   { procedura SetFillStyle ustala kolor i wzorzec wypenienia }
   SetFillStyle(SolidFill,0);

   { procedura FloodFill wypenia ograniczony obszar aktualnym }
   { wzorcem wypenienia }
   FloodFill(x,y,0);
   trojkat(bok,x,y);
   if stopien > 0 then
     wytnij_trojkat(stopien,bok,x,y);
end;


var
  ster, tryb,
  kodB,
  stopien : Integer;

begin
 writeln('Program rysuje trjktny dywan Sierpiskiego');
 repeat
   write('Podaj stopie (max 10): ');
   readln(stopien);
 until (stopien>=0) and (stopien<=10);

 { procedura DetectGraph rozpoznaje kart graficzn i domylny tryb }
 { graficzny dla danej karty }
 { ster - zmienna zawiera kod zainstalowanej w systemie karty graficznej }
 { tryb - zmienna zawiera domylny dla danej karty tryb graficzny }
 DetectGraph(ster, tryb);

 { procedura InitGraph inicjalizuje system graficzny na podstawie }
 { okrelonych w procedurze zmiennych ster i tryb }
 { Ostatni parametr dla Free Pascala pozostaje pusty }
 InitGraph(ster, tryb, '');

 kodB:=GraphResult;
 if kodB <> grOk then
 begin
   writeln ('Inicjacja trybu graficznego nie powioda si. Kod bdu ', kodB);
 end else
 begin
   dywan(stopien);
   repeat until Keypressed;

   { Procedura CloseGraph powoduje powrt z trybu graficznego do tekstowego }
   CloseGraph;
 end;
end.
