{ program rysuje patek Kocha }
program platek_Kocha;

uses
  Crt, Graph;

type
  { Tablica przechowujca wierzchoki trjkta }
  { Mona byo rwnie zastosowa rekord zawierajcy trzy rekordy }
  { okrelajce poszczeglne punkty - wsprzdne punktw -  podobnie }
  { jak przy zagadnieniu z odcinkami, ale w tym przypadku jest atwiej }
  WspolrzedneTrojkata = array [1..3, 1..2] of Real;

{ Procedura oblicza wszystkie trzy wsprzdne (x,y) trjkta }
{ Funkcje cos i sin w argumencie wymagaj radianw dlatego te }
{ przeliczamy stopnie na radiany, czyli mnoymy stopnie przez Pi/180 }
procedure wsp_trojkata(r : Integer; var wspTrojkat : WspolrzedneTrojkata);
var
  i : integer;
begin
  for i:= 1 to 3 do
    begin
      { Funkcja GetMaxX - zwraca maksymalna warto wsprzdnej }
      { poziomej X dla aktualnego trybu graficznego }
      WspTrojkat[i,1]:= (GetMaxX div 2) + r*cos((60+i*120)*Pi/180);

      { funkcja GetMaxY - zwraca maksymalna warto wsprzdnej }
      { poziomej Y dla aktualnego trybu graficznego }
      WspTrojkat[i,2]:= (GetMaxY div 2) + r*sin((60+i*120)*Pi/180);
    end;
end;

{ Procedura rysuje patek Kocha, o nastpujcych parametrach: }
{ stopien - poziom rekurencji }
{ x1,y1 - wsprzdne pocztku boku trjkta }
{ x2,y2 - wsprzdne koca boku trjkta }
procedure Koch(stopien : Integer; x1,y1,x2,y2 : Real);
var
  x,y: Real;
begin
  x:=x2-x1;
  y:=y2-y1;
  if stopien > 0 then
    begin
      Dec(stopien);

      { wsprzdne koca staj si wsprzdnymi pocztku nastpnego }
      { wywoania procedury Koch - po to aby odcinki si ze sob stykay }
      Koch(stopien, x1, y1, x1+x/3, y1+y/3);

      Koch(stopien, x1+x/3, y1+y/3, (x1+x2)/2+Sqrt(3)/6*y, (y1+y2)/2-Sqrt(3)/6*x);

      Koch(stopien, (x1+x2)/2+Sqrt(3)/6*y, (y1+y2)/2-Sqrt(3)/6*x,x1+x*2/3, y1+y*2/3);

      Koch(stopien, x1+x*2/3, y1+y*2/3, x2, y2);
    end
  else
    { Procedura Line, rysuje lini o pocztku we wsprzdnych (x1,y1) }
    { i kocu (x2,y2). Argumenty zaokrglamy bo musz by typu Integer }
    Line(Round(x1), Round(y1), Round(x2), Round(y2));
end;

var
  wspT : WspolrzedneTrojkata;
  i,
  pocz, kon,
  kodB,
  stopien,
  ster, tryb: Integer;

begin
  writeln('Program rysuje patek Kocha');
  repeat
    write('Podaj stopie (max 10): ');
    readln(stopien);
  until (stopien>=0) and (stopien<=10);

  { Procedura  DetectGraph rozpoznaje kart graficzna i domylny tryb }
  { graficzny dla danej karty }
  { ster - zmienna zawiera kod zainstalowanej w systemie karty graficznej }
  { tryb - zmienna zawiera domylny dla danej karty tryb graficzny }
  DetectGraph(ster, tryb);

  { Procedura InitGraph inicjalizuje system graficzny na podstawie }
  { okrelonych w procedurze zmiennych ster i tryb }
  { Ostatni parametr dla Free Pascala pozostaje pusty }
  InitGraph(ster, tryb, '');

  kodB:=GraphResult;
  if kodB <> grOk then
  begin
    writeln ('Inicjacja trybu graficznego nie powioda si. Kod bledu ', kodB);
  end else begin
    wsp_trojkata(GetMaxY div 2, wspT);
    for i:= 1 to 3 do
      begin
        pocz:= i;
        kon:= i+1;
        if kon>3 then kon:= 1;
        Koch(stopien, wspT[pocz, 1], wspT[pocz, 2], wspT[kon, 1], wspT[kon, 2]);
      end;
    repeat until Keypressed;

    { Procedura CloseGraph powoduje powrt z trybu graficznego do tekstowego }
    CloseGraph;
  end;
end.
Sprawd ile czasu zajmuje namalowanie patka Kocha dla stopnia n=10
