program palindrom;
uses
  Crt;

type
{ Tablica przechowuje informacje o znalezionych palindromach }
 TDanePalindromu = record
   poczatek,          { pocztek palindromu }
   dlugosc  : Byte    { dugo palindromu  }
 end;

 TTabDanePalindromu = array [1..500] of TDanePalindromu;

procedure czytaj_lancuch(var lancuch : String);
var
  znak : Char;
  koniec : Boolean;
begin
  lancuch:= '';
  koniec:=false;
  repeat
    znak:=Upcase(readkey);
    case znak of
       'A'..'Z' : begin
                    lancuch:=lancuch+znak;
                    write(znak);
                  end;
       #8       : if length(lancuch)>0 then
                    begin
                      lancuch[0]:=char(byte(lancuch[0])-1);
                      gotoxy(wherex-1,wherey);
                      write(' ');
                      gotoxy(wherex-1,wherey);
                    end;

       #27      : koniec:=true;
    end;

  until (znak=#13) or koniec;
  writeln;
  writeln;
end;

{ Funkcja sprawdza czy acuch o danej dugoci jest palindromem, czyli }
{ czy znak na 1 miejscu jest rwny znakowi na miejscu dlugosc }
{ czy znak na 2 miejscu jest rwny znakowi na miejscu dlugosc - 1 }
{ czy znak na 3 miejscu jest rwny znakowi na miejscu dlugosc - 2 ... }
function czy_palindrom (lancuch : String) : Boolean;
var
  i,
  dlugosc : Byte;
  wynik : Boolean;
begin
  wynik := true;
  dlugosc := length(lancuch);
  if dlugosc<2 then wynik:=false
  else
    for i:= 1 to dlugosc do
      if lancuch[i]<>lancuch[dlugosc+1-i] then wynik:= false;
  czy_palindrom:=wynik;
end;

{ Procedura wyszukuje najduszy palindrom w acuchu znakw. }
{ W pierwszej kolejnoci bada cigi znakw o dugoci wyjciowej }
{ dugo, nastpnie wszystkie podcigi dlugosc-1, dlugosci-2.... }
procedure znajdz_najdluzszy(lancuch : String);
var
  dl, pocz,
  dlugosc : Integer;
  pom : String;
  dalej : Boolean;
begin
  dalej:=true;
  dlugosc:=length(lancuch);
  dl:=dlugosc;
  writeln('Najdusze palindromy:');
  repeat
  { Sprawdzanie zaczynamy od acucha wyjciowego }
  { i koczymy gdy znajdziemy najduszy palindrom }
    while (dl>1) and (dalej) do
      begin
        for pocz:=1 to dlugosc+1-dl do
          begin
            pom:= copy (lancuch,pocz,dl);
            if czy_palindrom (pom) then
              begin
                writeln(pom);
                dalej:=false;
              end;
          end;
          dec(dl);
      end;
    dec(dl)
  until (dl<2) or not (dalej);

  if dalej then write('Brak palindromw');
end;

function czy_brak(pocz, dl: Byte; tabDanePali: TTabDanePalindromu; indeks : Integer) : Boolean;
var
  wynik : Boolean;
  i     : Integer;
begin
  wynik:=true;
  for i:=1 to indeks+1 do
    with tabDanePali[i] do
      if (poczatek<=pocz)and(poczatek + dlugosc>=pocz+dl) then
        wynik:=false;
  czy_brak:=wynik;
end;

{ Procedura znajduje wszystkie palindromy w acuchu znakw. }
{ W tablicy tabDanePali s przechowywane dane o znalezionych }
{ palindromach: pocztku i jego dugo }
procedure znajdz_wszystkie(var lancuch : String);
var
 pocz, dl,
 dlugosc : Byte;
 pom : String;
 tabDanePali : TTabDanePalindromu;
 licznik : Integer; { zmienna przechowujca ilo palindromw }
                    { przy pomocy niej odwoujemy si do tablicy }
begin
  licznik:=0;
  writeln('Wszystkie palindromy:');
  fillchar(tabDanePali, sizeof(tabDanePali),0);
  dlugosc:=length(lancuch);
  for dl:=dlugosc downto 2 do
    begin
      for pocz:=1 to dlugosc+1-dl do
        begin
          if czy_brak(pocz,dl,tabDanePali,licznik) then begin
            pom:=copy(lancuch,pocz,dl);
            if czy_palindrom(pom) then begin
              inc(licznik);
              tabdanePali[licznik].poczatek:=pocz;
              tabdanePali[licznik].dlugosc:=dl;
              writeln(pom);
            end;
          end;
       end;
    end;

 if licznik=0 then  write('Brak palindromw');
end;

var
  lancuch : String;
begin
  ClrScr;
  writeln('Program sprawdzi czy istniej palindromy. Jeli istniej, to wyszuka najdusze.');
  writeln('Podaj acuch:');
  czytaj_lancuch(lancuch);
  if lancuch <>'' then begin
    znajdz_najdluzszy(lancuch);
    writeln;
    znajdz_wszystkie(lancuch);
  end else
    writeln('Wprowadzony acuch jest pusty');
  repeat until keypressed;
end.
