{ Program wyszukuje wzorzec w tekcie metod Boyera-Moore'a }
program wyszukiwanie_BM;

uses
  Crt,
  Math;  { w tym module mamy funkcje max }

const
  DLLancucha  = 50;    { dugo acucha }
  DLWzorca    =  3;    { dugo wzorca  }

  { nasz alfabet bdzie si skada si z trzech liter XYZ,  }
  { z ktrych losowo wygenerujemy acuch }
  ZnPocz = 88;  { kod pierwszego znaku alfabetu, X }
  ZnKonc = 90;  { kod ostatniego znaku alfabetu, Y }

type
  { Definiujemy tablic, ktrej indeksy odpowiadaj kodom znakw }
  { czyli np. dla ZnPocz=88 i ZnKonc=89 tablica jest dwuelementowa, }
  { indeksowana kodami liter: X i Y }
  { Natomiast elementami tablicy s ostatnie pozycje danej litery }
  { we wzorcu, czyli dla wzorca XYXYX TabOstPozycji[88]=5,
  { TabOstPozycji[89]=4 }
  TTabOstPozycji = array [ZnPocz..ZnKonc] of Integer;

procedure wyszukaj_wzorca_III (lancuch, wzorzec : String );
var
  TabOstPozycji : TTabOstPozycji;
  i,j,
  ile,            { ilo wystpie wzorca }
  PozW : Integer; { pozycja wzorca w acuchu }
begin
  writeln('Metoda Boyera-Moore''a:');
  writeln(lancuch);
  ile:=0;

  { zerujemy tablic }
  for i := ZnPocz to ZnKonc
    do TabOstPozycji[i] := 0;

  { wypenimy tablice ostatnimi wystpieniami danych liter we wzorcu }
  for i := 1 to DLWzorca
    do TabOstPozycji[ ord(wzorzec[i]) ] := i;

  { szukamy pozycji wzorca w acuchu }
  i    := 1;
  pozW := 1;
  while i <= DLLancucha - DLWzorca + 1 do
    begin
      j := DLWzorca;
      { sprawdzamy zgodno liter we wzorcu i acuchu }
      { sprawdzanie zaczynamy od koca }
      while (j > 0) and (wzorzec[j] = lancuch[i + j - 1]) do
        dec(j);

      { jeli wyszukalimy wzorzec, zaznaczamy jego pocztek }
      if j = 0 then
        begin
          while pozW < i do
            begin
              write(' ');
              inc(pozW);
            end;
          write(char(24));
          inc(i);
          inc(pozW);
          inc(ile);
        end
      else
        { jeli wystpi niezgodnoci liter przesuwamy wzorzec }
        { na odpowiednia pozycje }
        inc(i,max(1,j - TabOstPozycji[ ord(lancuch[i+j-1])]));
    end;
  writeln;
  writeln('Ilo wystpie wzorca: ',ile);
end;

var
  i       : Integer;
  lancuch,
  wzorzec : String;

begin
  ClrScr;

  randomize;

  lancuch:='';
  wzorzec:='';

  { generujemy acuch }
  for i := 1 to DLLancucha do
    lancuch := lancuch + chr(ZnPocz + random(ZnKonc - ZnPocz + 1));

  writeln('Tekst, w ktrym bdziemy szuka wzorca:');
  writeln(lancuch);
  writeln;

  { generujemy wzorzec }
  for i := 1 to DLWzorca do
    wzorzec := wzorzec + chr(ZnPocz + random(ZnKonc - ZnPocz + 1));
  writeln('Szukany wzorzec:');
  writeln(wzorzec);
  writeln;

  wyszukaj_wzorca_III (lancuch, wzorzec);
  repeat until keypressed;
end.
