program alfabet_Morsa;

uses
  Crt;

type
  TZnakKod = record
     znak : Char;    { litera lub cyfra }
     kod  : String  { kod kreskowo-kropkowy }
  end;

const
  T = 50;          { czas trwania kropki w milisekundach }
  F = 500;         { czstotliwo dwiku }
  IleZnakow = 37;  { ilo znakw w tabeli }

  tabKod : array[1..IleZnakow] of TZnakKod = { litery, liczby i ich kody Morse'a }

    ((znak:'A'; kod:'.-'),    (znak:'B'; kod:'-...'),
     (znak:'C'; kod:'-.-.'),  (znak:'D'; kod:'-..'),
     (znak:'E'; kod:'.'),     (znak:'F'; kod:'..-.'),
     (znak:'G'; kod:'--.'),   (znak:'H'; kod:'....'),
     (znak:'I'; kod:'..'),    (znak:'J'; kod:'.---'),
     (znak:'K'; kod:'-.-'),   (znak:'L'; kod:'.-..'),
     (znak:'M'; kod:'--'),    (znak:'N'; kod:'-.'),
     (znak:'O'; kod:'---'),   (znak:'P'; kod:'.--.'),
     (znak:'Q'; kod:'--.-'),  (znak:'R'; kod:'.-.'),
     (znak:'S'; kod:'...'),   (znak:'T'; kod:'-'),
     (znak:'U'; kod:'..-'),   (znak:'V'; kod:'...-'),
     (znak:'W'; kod:'.--'),   (znak:'X'; kod:'-..-'),
     (znak:'Y'; kod:'-.--'),  (znak:'Z'; kod:'--..'),
     (znak:'1'; kod:'.----'), (znak:'2'; kod:'..---'),
     (znak:'3'; kod:'...--'), (znak:'4'; kod:'....-'),
     (znak:'5'; kod:'.....'), (znak:'6'; kod:'-....'),
     (znak:'7'; kod:'--...'), (znak:'8'; kod:'---..'),
     (znak:'9'; kod:'----.'), (znak:'0'; kod:'-----'),
     (znak:#32; kod:'/\')    );{(znak:#1013; kod:'||') );}

{ Funkcja sprawdza czy znak jest w tabeli, czyli czy ma swj kod }
{ Jeli go znajdzie zmienna kod zwraca jego kod. W wyniku funkcji }
{ zwracana jest informacja czy znak ma swj odpowiednik w postaci kodu }
function znajdz_kod(zn : Char; var kod : String) : Boolean;
var
  jest : Boolean;
  i : Integer;
begin
  jest:=false;
  i:=1;
  repeat
    if tabKod[i].znak=zn then
      begin
        kod:=tabKod[i].kod;
        jest:=true
      end
    else inc(i)
   until jest or (i=IleZnakow+1);
   if not jest then kod:='BRAK';
  znajdz_kod:=jest;
end;

{ Procedura zamienia dany znak na kod Morse'a oraz kod dwikowy }
procedure zakoduj_znak (z : Char);
var
  i : Integer;
  kod : String;
begin
  { generujemy sygna dwikowy o czstotliwoci T }
  { przyjmujemy czas trwania: }
  { kropki = T }
  { kreski = 3T }
  { odstp miedzy kadym sygnaem (kropka lub kreska) = T/2 }
  { odstp miedzy znakiem (litera lub cyfra) = 3T }
  { odstp miedzy wyrazami =9T }
  if znajdz_kod(z,kod) then
    for i:=1 to length(kod) do
      begin
        if kod[i]='.' then
          begin
            sound(F);
            delay(T);      { kropka }
            nosound;
            delay(T div 2) { przerwa po kadym sygnalne };
          end
        else
          if kod[i]='-' then
            begin
              sound(F);
              delay(3*T);    { kreska }
              nosound;
              delay(T div 2) { przerwa po kadym sygnalne }
            end
          else
            delay(3*3*T);
      end

  else delay(3*3*T); { pauza=9T, gdy znak spoza zestawu }
  delay(3*T);        { przerwa=3T, po kadym znaku }
  textcolor(green);
  write(kod,'  ');
end;

procedure zakoduj_morsem (tekst : String);
var
  i : Integer;
begin
  { zamieniamy wszystkie litery w tekcie na due litery. Dla kodowania Morsem }
  { wielko liter nie ma znaczenia, a nam uatwi prac }

  for i:=1 to length(tekst) do
    zakoduj_znak(UpCase(tekst[i]));
end;
var
  tekst : String; { wprowadzany tekst }
begin
  clrscr;
  writeln('Program koduje znaki alfabetem Morse''a');
  writeln('Podaj tekst skadajcy si z liter i cyfr (bez polskich znakw)');
  writeln;
  readln(tekst);
  writeln;
  zakoduj_morsem(tekst);

  repeat until keypressed;
end.
