program wielomiany;
uses
  Crt;
const
  n = 4;
type
  TTablica = array [0..n] of Real;

procedure ZerujTablice(var t : TTablica; n : Integer );
var
  i : Integer;
begin
  for i:=0 to n do t[i]:=0;
end;

function wielo_Horner_iter( a : TTablica; n : Integer; x0 : Real) : Real;
var
  i : Integer;
  b : Real;
begin
  b:=a[0];          { pierwszy wyraz }
  for i:=1 to n do
  { kady nastpny wyraz powstaje z poprzedniej wartoci b pomnoonej przez liczb x0 }
    b:=b*x0+a[i];   { i dodania do iloczynu kolejnego wspczynnika wielomianu. }

  wielo_Horner_iter:=b;
end;

function wielo_Horner_rek( a : TTablica; n : Integer; x : Real) : Real;
begin
  if n=0 then
    wielo_Horner_rek:=a[0]  { pierwszy wyraz }
  else
    wielo_Horner_rek:=wielo_Horner_rek(a,n-1,x)*x + a[n]; { wywoujemy funkcj rekurencyjnie }
end;

var
  a  : TTablica;
  i  : Integer;
  x  : Real;
begin
  clrscr;
  ZerujTablice(a,n);
  writeln('Obliczanie wartoci wielomianu za pomoc schematu Hornera:');
  writeln('Podaj wspczynniki wielomianu: ');
  for i:= 0 to n do
    begin
      write('Wspczynnik przy potdze ',n-i,' a',i,'=');
      readln(a[i]);
    end;
  write('Podaj liczb, dla ktrej obliczymy warto wielomianu: ');
  readln(x);

  writeln('----------------------------------------------------');
  writeln('Metoda iteracyjna');
  writeln('Warto wielomianu dla liczby ',x:8:2,' wynosi: ',wielo_Horner_iter(a,n,x):8:2);

  writeln('----------------------------------------------------');
  writeln('Metoda rekurencyjna');
  writeln('Warto wielomianu dla liczby ',x:8:2,' wynosi: ',wielo_Horner_rek(a,n,x):8:2);

  repeat until keypressed;
end.
