program metoda_polowienia;
uses
  Crt;
const
  Epsilion_0  = 0.00001; { dokadno z jak porwnujemy z zerem }
  Epsilion_x0 = 0.000001; { dokadno z jak wyznaczamy pierwiastek }

{ Funkcja, dla ktrej obliczamy miejsce zerowe }
{ Jeli chcesz zmieni funkcj(nie musi to by funkcja wielomianowa) }
{ wystarczy, ze zmodyfikujesz to miejsce }
{ f(x)=x^5+3x^4-8x^2-9x-3, posiada np. pierwiastek x=-1.7321 }
function f(x : real) : real;
begin
  f:=x*x*x*x*x + 3*x*x*x*x - 8*x*x - 9*x - 3;
end;

{ Funkcja poszukuje pierwiastka w podanym przedziale <a,b> }
{ Jeli go znajdzie, to w wyniku zwrci True, a w zmiennej x0 }
{ warto argumentu, dla ktrej f(x0)=0 }
{ Jeli go nie znajdzie, to funkcja w wyniku zwrci False }
{ warto zmiennej x0 nie ma wtedy znaczenia }
function wyznacz_pierwiastek(a,b : Real; var x0 : Real) : Boolean;
var
  fa,
  fb,
  fx0 : Real; { wartoci funkcji, odpowiednio w punktach a,b,x0 }
  Jest : Boolean;   { zmienna informujca czy jest miejsce zerowe funkcji }
begin
  Jest := False;
  fa := f(a);
  fb := f(b);
  if fa * fb < 0 then
    { dopki przedzia nie jest taki may i nie znalelimy pierwiastka }
    while (abs(a - b) > Epsilion_x0) and (Not Jest) do
      begin
        x0  := (a + b) / 2; { wyznaczamy nastpny rodek }
        fx0 := f(x0);       { badamy jak warto przyjmuje funkcja w pkt x0 }
        if abs(fx0) < Epsilion_0 then
        { jeli warto funkcji jest zero lub bardzo blisko zera koczymy szukanie }
        Jest:=True;

        if Not Jest then { jeli nie by to pierwiastek, szukamy dalej }
          begin
            if fa * fx0 < 0 then { sprawdzamy, w ktrym przedziale funkcja ma rne znaki }
              b := x0
            else
              begin
                a := x0;
                fa := fx0;
              end;
          end
    end
  else
    writeln('Funkcja nie spenia trzeciego warunku');

  wyznacz_pierwiastek:=Jest;
end;

var
  a,b,               { lewy i prawy koniec przedziau }
  x0 : Real;         { rodek przedziau, przyblienie pierwiastka }
begin
  clrscr;
  writeln('Obliczanie pierwiastka funkcji - metod poowienia (bisekcji)');
  writeln('f(x)=x^5+3x^4-8x^2-9x-3');
  writeln;
  writeln('Podaj przedzia poszukiwa pierwiastka:');
  writeln;
  write('a = ');
  readln(a);
  write('b = ');
  readln(b);
  { dodaj zabezpieczenia przed wprowadzeniem nieprawidowych danych }
  if wyznacz_pierwiastek(a,b,x0) then
    writeln('Funkcja posiada pierwiastek x0 = ',x0:8:4)
  else
    writeln('Funkcja nie posiada pierwiastka w przedziale <',a:6:4,',',b:6:4,'>');

  repeat until keypressed;
end.
